<?php

namespace src;

class Form {

    /**
     * @param string $action
     * @return void
     */
    public function beginForm(string $action): void
    {
        echo "<form action='$action'>";
    }

    /**
     *  Генерация текстового инпута
     *
     * @param string $name
     * @param array $paramsArray
     * @return void
     */
    public function input(string $name, array $paramsArray = []): void
    {
        $paramsString = $this->createParams($paramsArray);
        echo "<input name='$name' $paramsString >";
    }

    /**
     * @param array $data
     * @return string
     */
    public function createParams(array $data = []): string
    {
        $paramsString = "";
        foreach($data as $key => $param){
            $paramsString .= $key . "='" . $param . "'";
        }

        return $paramsString;
    }

    /**
     * @param string $name
     * @param string $value
     * @param array $paramsArray
     * @return void
     */
    public function createCheckbox(string $name, string $value, array $paramsArray = []): void
    {
        $paramsString = $this->createParams($paramsArray);
        echo "<input name='$name' type='checkbox' value='$value' $paramsString >";

    }

    /**
     * @param string $title
     * @param array $paramsArray
     * @return void
     */
    public function createLabel(string $title, array $paramsArray = []): void
    {
        $paramsString = $this->createParams($paramsArray);
        echo "<label $paramsString >$title</label>";
    }

    /**
     * @param string $name
     * @param array $paramsArray
     * @return void
     */
    public function createRadio(string $name, array $paramsArray = []): void
    {
        $paramsString = $this->createParams($paramsArray);
        echo "<input name='$name' type='radio' $paramsString>";
    }

    /**
     * @param string $name
     * @param string $value
     * @param array $paramsArray
     * @return void
     */
    public function createTextarea(string $name, string $value = "", array $paramsArray = []): void
    {
        $paramsString = $this->createParams($paramsArray);
        echo "<textarea name='$name' $paramsString>$value</textarea>";
    }
    /**
     * @return void
     */
    public function endForm(): void
    {
        echo "</form>";

    }
}
